<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
function DeleteOldPmsAdminArea(&$admin_areas)
{
	global $txt;
	
	loadLanguage('DeleteOldPms');
	
	return $admin_areas['config']['areas']['modsettings']['subsections'] += array('deleteoldpms' => array(sprintf($txt['deleteoldpms_settings'])));
}

function DeleteOldPmsSubAction(&$subActions)
{
	return $subActions += array('deleteoldpms' => 'DeleteOldPmsSettings');
}

function DeleteOldPmsSettings($return_config = false) 
{
	global $context, $txt, $scripturl, $modSettings, $settings;
	
	$context['page_title'] = $txt['deleteoldpms_settings'];

	$config_vars = array(
		array('check', 'enable_delete_old_pms'),
		array('text', 'delete_old_pms_days'),
	);
	
	$context['settings_save_onclick'] = 'confirm(\'' . $txt['confirm_old_pms_deletion'] . '\');';

	if ($return_config)
		return $config_vars;

	if (isset($_GET['save'])) 
	{
		checkSession();

		saveDBSettings($config_vars);
		writeLog();

		redirectexit('action=admin;area=modsettings;sa=deleteoldpms');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=deleteoldpms';

	prepareDBSettingContext($config_vars);
}

// This function allows the admin to delete all messages older than so many days.
function scheduled_delete_oldpms()
{
	global $smcFunc, $modSettings;

	$modSettings['delete_old_pms_days'] = !empty($modSettings['delete_old_pms_days']) ? (int) $modSettings['delete_old_pms_days'] : 0; 
	
	//Delete old pms? Be aware, that this action can not be undone.
	if(!empty($modSettings['enable_delete_old_pms']) AND !empty($modSettings['delete_old_pms_days']))
    {
	    // Array to store the IDs in.
		$toDelete = array();
		
		// Array to store the pm counter in.
		$newCounter = array();

		$request = $smcFunc['db_query']('', '
			SELECT pm.id_pm, pm.msgtime, pr.id_member, pr.is_new
			FROM {db_prefix}personal_messages pm
			   INNER JOIN {db_prefix}pm_recipients AS pr ON (pm.id_pm = pr.id_pm)
			WHERE pm.msgtime < {int:msgtime}
			      AND pr.is_new = {int:not_new}',
			array(
			     'msgtime' => time() - ($modSettings['delete_old_pms_days'] * 86400),
			     'not_new' => 0,
		    )
		);

		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$toDelete[] = $row['id_pm'];

			if (!empty($row['is_new']))
				$newCounter[] = $row['id_member'];
		}
		
		$smcFunc['db_free_result']($request);

		// Do the actual deletion.
		if (!empty($toDelete))
		{
			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}personal_messages
				       WHERE id_pm IN ({array_int:pm_list})',
				array(
					'pm_list' => $toDelete,
				)
			);

			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}pm_recipients
				       WHERE id_pm IN ({array_int:pm_list})',
				array(
					'pm_list' => $toDelete,
				)
			);
		}

		//We need to make their message count correct.
		if (!empty($newCounter))
		{
			foreach ($newCounter as $member => $v)
			{
				updateMemberData($member, array('instant_messages' => 'instant_messages - '.$v.'', 'unread_messages' => 'unread_messages - '.$v.''));
			}	
		}
	}
	
	return true;
}